<template>
  <v-data-table
    :headers="headers"
    :loading="loading"
    :items="areas"
    :page="page + 1"
    :items-per-page="pageSize"
    :server-items-length="total"
    class="elevation-1"
    @click:row="goToDetails"
  >
    <template #item.id="{ item }">
      {{ hashId({ id: item.id }) }}
    </template>

    <template #item.capacity="{ item }">
      {{ availableCapacityFormat(item.availableCapacity, item.totalCapacity) }}
    </template>
  </v-data-table>
</template>

<script>
import { mapActions, mapState } from 'vuex';
import { availableCapacityFormat } from '~/helpers/format/capacity';
import { hashId } from '~/helpers/format/ids';

export default {
  name: 'AreasTable',
  data: () => ({
    loading: false,
    headers: [
      {
        text: 'Nª',
        align: 'start',
        sortable: false,
        value: 'id',
      },
      {
        text: 'Descripción',
        sortable: false,
        value: 'description',
      },
      {
        text: 'Capacidad disponible (pallets)',
        align: 'center',
        sortable: false,
        value: 'capacity',
      },
    ],
  }),
  computed: {
    ...mapState({
      areas: state => state.storage.areas.areas,
      page: state => state.storage.areas.pageInfo.page,
      pageSize: state => state.storage.areas.pageInfo.pageSize,
      total: state => state.storage.areas.pageInfo.total,
    }),
  },
  async mounted() {
    await this.getAreasData();
  },
  methods: {
    hashId,
    availableCapacityFormat,
    ...mapActions({
      getAreas: 'storage/areas/getAreas',
    }),
    async getAreasData() {
      this.loading = true;
      try {
        await this.getAreas({});
      } catch (e) {
        console.error(e);
      }
      this.loading = false;
    },
    async goToDetails({ id }) {
      await this.$router.push(`/almacenamiento/zonas/${id}`);
    },
  },
};
</script>
